package concours;

import java.util.HashMap;
import java.util.Map;

public final class VotesList {

	private Map<String, VoteInfo> votes = new HashMap<String, VoteInfo>();
	private int totalVotes = 0;
	
	public synchronized boolean addVote(String id, CandidatesList cands) {
		if ((cands == null) || !cands.isCandidate(id)) {
			return false;
		}
		
		VoteInfo info;
		if (votes.containsKey(id)) {
			info = votes.get(id);
		}
		else {
			info = new VoteInfo();
		}
		
		info.addVote();
		votes.put(id, info);
		totalVotes++;
		return true;
	}
	
	public synchronized VoteInfo getVoteInfo(String id) {
		if (id == null) {
			return null;
		}
		
		return votes.containsKey(id)
			? votes.get(id)
			: new VoteInfo();
	}
	
	public synchronized int getTotalVotes() {
		return totalVotes;
	}
}
